; Zyklisch Zeit und Zufallswerte in eine Datei schreiben
; ======================================================
;
; AutoIt Version: 3.2.12.1
; OS: Windows 2000 / XP deutsch
; Autor: Manfred - 15.10.2022
; 16.10.2022 - Zeitschleife mit <> @sec anstatt delay
; 16.10.2022 - Fehlermeldunf wenn FileOpen fehlschlaegt
; 

$Version = "Version : 2022-10-16"
; $Version = $Version &@CRLF &"Running  with : " &@AutoItVersion

$OutFile = "H:\Testfile.txt"

Global $Start = 0
Global $Loopct = 0
Global $LastSec = 66
Global $Uhrzeit

#include <GuiConstants.au3>
Opt("GUICloseOnESC", 1)      ;1=ESC  closes, 0=ESC won't close
Opt("TrayAutoPause",0)       ;0=no pause, 1=Pause
Opt("TrayIconHide", 0)       ;0=show, 1=hide tray icon
Opt("GUIOnEventMode", 1)     ;0=disabled, 1=OnEvent mode enabled

$Gui = "SD - Karte testen  //  " &$Version
GuiCreate($Gui, 350, 200, 20, 20, -1, 0x00000018); WS_EX_ACCEPTFILES
 GUISetBkColor ("0xFDCB16")
 GUISetOnEvent($GUI_EVENT_CLOSE, "ExitEvent")
 GuiSetState()
 WinSetOnTop ($GUI, "", 0)

$ButtonStart = GUICtrlCreateButton ("Start", 20, 30, 145, 40)
 GUICtrlSetFont ($ButtonStart, 15, 900, 1, "Courier New")
 GUICtrlSetOnEvent ($ButtonStart, "ButtStart")

$ButtonStop = GUICtrlCreateButton ("Beenden", 185, 30, 145, 40)
 GUICtrlSetFont ($ButtonStop, 15, 900, 1, "Courier New")
 GUICtrlSetOnEvent ($ButtonStop, "ExitEvent")

$Time = GUICtrlCreateLabel (@AutoItVersion, 180, 90, 150, 30, 0x1)
 GUICtrlSetBkColor (-1, "0xC6DCF6")
 GUICtrlSetFont ($Time, 20, 900, 1, "Courier New")

$Count = GUICtrlCreateLabel ("Auto-IT", 20, 90, 140, 30, 0x1)
  GUICtrlSetBkColor (-1, "0xC6DCF6")
 GUICtrlSetFont ($Count, 20, 900, 1, "Courier New")

$Filename = GUICtrlCreateLabel ($OutFile, 20, 140, 310, 25, 0x1)
  GUICtrlSetBkColor (-1, "0xC6DCF6")
 GUICtrlSetFont ($Filename, 15, 900, 1, "Courier New")

Do  ; warten auf Button Start
  sleep (10) ; ohne zieht es Last !!
  If $Start = 1  And @SEC <> $LastSec Then
    $LastSec = @SEC
    GUICtrlSetData ($Time, $Uhrzeit)
    GUICtrlSetData ($Count, $Loopct)
    WriteToFile()
    $Loopct = $Loopct + 1
  EndIf
Until $Loopct = -735 ; wird niemals zutreffen

Func OutFileName()
        $OutFile = $LogFile
EndFunc

Func WriteToFile()
  $OutFileTAN = FileOpen($Outfile, 1) ; 1 = Append / 4 = Overwrite
  If $OutFileTAN = -1 Then
    GUICtrlSetData ($Count, "Error")
    GUICtrlSetData ($Time, "no File")
    MsgBox (262144 + 16, "Error", "Kann File nicht oeffnen!" &@CRLF &"== Abbruch ==")
    $Start = 0
    Return
  EndIf
  $Uhrzeit = @hour&":"&@min&":"&@sec
  FileWrite($OutFileTAN, $Uhrzeit &";")
  Local $Volt = Random(10, 13, 1)
  Local $Millivolt = Random(1000, 9999, 1)
  FileWrite($OutFileTAN, $Volt&","&$Millivolt&";")
  If (@sec = 20) Or (@sec = 50) Then
    Local $AVolt = Random(3, 4, 1)
    Local $AMillivolt = Random(1000, 9999, 1)
    FileWrite($OutFileTAN, $AVolt&","&$AMillivolt&";")
  EndIf
  FileWrite($OutFileTAN, @CRLF)
  FileClose($OutFileTAN)
EndFunc

Func ButtStart()
  If $Start <> 1 Then
    $Loopct = 0
    PosBeep()
    $LastSec = @SEC
    GUICtrlSetState ($ButtonStart, $GUI_DISABLE)
    $Start = 1
  Else
    ErrBeep()
  EndIf  
EndFunc

Func ExitEvent()  ; Button Abbruch / Beenden / Exit
  PosBeep()
  sleep (50)
  Exit
EndFunc

Func PosBeep()
  Beep(700, 77)
  sleep (100)
  Beep(950, 75)
EndFunc

Func ErrBeep()
  Beep(333, 170)
EndFunc